﻿Imports System.Drawing.Printing

Public Class Form1
    ' List the available printers.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each printer As String In PrinterSettings.InstalledPrinters
            cboPrinter.Items.Add(printer)
        Next printer
    End Sub

    ' Print.
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        ' Select the printer.
        pdocSmiley.PrinterSettings.PrinterName = cboPrinter.Text

        ' Print.
        pdocSmiley.Print()
    End Sub

    ' Draw the smiley face.
    Private Sub pdocSmiley_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles pdocSmiley.PrintPage
        e.Graphics.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.AntiAlias

        e.Graphics.TranslateTransform(1, 1)
        e.Graphics.ScaleTransform(100, 100, _
                System.Drawing.Drawing2D.MatrixOrder.Append)
        e.Graphics.TranslateTransform( _
            e.MarginBounds.X, _
            e.MarginBounds.Y, _
            System.Drawing.Drawing2D.MatrixOrder.Append)
        DrawSmiley(e.Graphics)
    End Sub

    ' Draw a smiley face in the area (-1, -1)-(1, 1).
    Private Sub DrawSmiley(ByVal gr As Graphics)
        Using thin_pen As New Pen(Color.Black, 0)
            gr.FillEllipse(Brushes.Yellow, -1, -1, 2, 2)
            gr.DrawEllipse(thin_pen, -1, -1, 2, 2)

            gr.FillEllipse(Brushes.LightGreen, -0.5F, -0.5F, 0.3F, 0.5F)
            gr.DrawEllipse(thin_pen, -0.5F, -0.5F, 0.3F, 0.5F)
            gr.FillEllipse(Brushes.Black, -0.4F, -0.4F, 0.2F, 0.3F)

            gr.FillEllipse(Brushes.LightGreen, 0.2F, -0.5F, 0.3F, 0.5F)
            gr.DrawEllipse(thin_pen, 0.2F, -0.5F, 0.3F, 0.5F)
            gr.FillEllipse(Brushes.Black, 0.3F, -0.4F, 0.2F, 0.3F)

            gr.FillEllipse(Brushes.LightBlue, -0.2F, -0.1F, 0.4F, 0.6F)
            gr.DrawEllipse(thin_pen, -0.2F, -0.1F, 0.4F, 0.6F)

            gr.DrawArc(thin_pen, -0.75F, -0.75F, 1.5F, 1.5F, 20, 120)
        End Using
    End Sub

    ' Display this printer's available resolutions.
    Private Sub cboPrinter_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboPrinter.SelectedIndexChanged
        ' Select the printer.
        pdocSmiley.PrinterSettings.PrinterName = cboPrinter.Text

        ' Display the available resolutions.
        cboResolution.Items.Clear()
        For Each resolution As PrinterResolution In _
                pdocSmiley.DefaultPageSettings.PrinterSettings.PrinterResolutions
            cboResolution.Items.Add(resolution.ToString())
        Next resolution

        ' Disable the Print button until the user picks a resolution.
        btnPrint.Enabled = (cboResolution.SelectedIndex > -1)
    End Sub

    ' Enable the Print button if a resolution is selected.
    Private Sub cboResolution_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboResolution.SelectedIndexChanged
        btnPrint.Enabled = (cboResolution.SelectedIndex > -1)
    End Sub
End Class
